(let 
    (
        (fcs (freecell-solver-make-instance))
        (board_ms24_string 
            (string-append 
                "4S 2S 9S 8S QC 4C 2H\n"
                "5H QH 3S AS 3H 4H QD\n"
                "QS 9C 6H 9H 3C KC 3D\n"
                "5D 2C JS 5S JH 6D AC\n"
                "2D KD 10H 10S 10D 8D\n"
                "7H JC KH 10C KS 7S\n"
                "AH 5C 6C AD 8H JD\n"
                "7C 6S 7D 4D 8C 9D\n"
            )
        )
        (board_pysol980662_string
            (string-append
                "5S AC 3S 6H 10D 4D KH\n"
                "AS 5H 4H QC KD 7H 10H\n"
                "5D QD 9D 8D 3C 3H 2S\n"
                "7C 4C 8S AH QS 7D 2C\n"
                "10C 9C JC JS 8H 9H\n"
                "6C 7S KC 2D 10S 5C\n"
                "QH 9S 6S 3D 6D JD\n"
                "4S AD KS 8C 2H JH\n"
            )
        )
        (board_ms11982_string
            (string-append
                "AH 3D KD JS 6S JD KS\n"
                "AC 3H 6H 5D 2S 7D 8D\n"
                "4H QC 5C 5S 10H 8H 2C\n"
                "AS QS 4D 8S QH 9S 3C\n"
                "2D 8C 9H 9D 6D 2H\n"
                "6C 7H JH 10D 10S QD\n"
                "10C AD 9C KH 4C 4S\n"
                "JC KC 3S 7S 7C 5H\n"
            )
        )
        (move #f)
        (limit 1000)
        (ret 0)
        (the-board "")
    )
    
    ;(set! the-board board_ms13_string)
    ;(set! the-board board_ms11982_string)
    (set! the-board board_pysol980662_string)
    
    (display fcs)
    (newline)
    (freecell-solver-limit-iterations fcs limit)
    (set! ret (freecell-solver-solve fcs the-board))
    (display "Limit is ")
    (display limit)
    (newline)
    (while (= ret FCS_STATE_SUSPEND_PROCESS)
        (set! limit (+ limit 1000))
        (freecell-solver-limit-iterations fcs limit)
        (set! ret (freecell-solver-resume fcs))
        (display "Limit is ")
        (display limit)
        (newline)
    )
    (if (= ret FCS_STATE_IS_NOT_SOLVEABLE)
        (begin
            (display "The game could not be solved")
            (newline)
        )
        ; Else
        (begin
            (display "Number of moves left is: ")
            (display (freecell-solver-get-moves-left fcs))
            (newline)     
            (display "FCS_STATE_WAS_SOLVED is: ")
            (display FCS_STATE_WAS_SOLVED)
            (newline)
            (set! move (freecell-solver-get-next-move fcs))
            (while move
                (display move)
                (newline)
                (set! move (freecell-solver-get-next-move fcs))
            )
        )
    )
)
